import * as Util from "../../util";
/**
 * Computes the sum of the sequence of numeric values that are obtained by invoking a transform function on each element of the input sequence.
 * @param selector A transform function to apply to each element.
 */
export function sumProto(selector) {
    if (selector === void 0) { selector = Util.defaultSelector; }
    return sumStatic(this.toArray(), selector);
}
/**
 * Computes the sum of the sequence of numeric values that are obtained by invoking a transform function on each element of the input sequence.
 * @param selector A transform function to apply to each element.
 */
export function sumStatic(source, selector) {
    if (selector === void 0) { selector = Util.defaultSelector; }
    return source.reduce(function (sum, item) { return sum + selector(item); }, 0);
}
//# sourceMappingURL=sum.js.map